////////////////////////////////////////////////////////////////
// ShadeCap Copyright 1996 Microsoft Systems Journal. 
// If this program works, it was written by Paul DiLascia.
// If not, I don't know who wrote it.
//
// ShadeCap illustrates how to draw your own caption with flicker-free
// painting in Windows 95. ShadeCap draws a shaded caption like the
// Microsoft Office 95 products. Compiles with MFC 4.1 under Windows 95.
//
#include "StdAfx.h"
#include "ShadeCap.h"
#include "MainFrm.h"
#include "Doc.h"
#include "View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CApp NEAR theApp;

BEGIN_MESSAGE_MAP(CApp, CWinApp)
	//{{AFX_MSG_MAP(CApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

CApp::CApp()
{
}

BOOL CApp::InitInstance()
{
	SetRegistryKey("MSJ");		// Save settings in registry, not INI file
	LoadStdProfileSettings();  // Standard INI file options (including MRU)

#ifdef _MDI
	AddDocTemplate(new CMultiDocTemplate(IDR_MYDOCTYPE,
		RUNTIME_CLASS(CMyDoc),
		RUNTIME_CLASS(CMDIChildWnd),
		RUNTIME_CLASS(CMyView)));
#else
	AddDocTemplate(new CSingleDocTemplate(IDR_MAINFRAME,
		RUNTIME_CLASS(CMyDoc),
		RUNTIME_CLASS(CMainFrame),
		RUNTIME_CLASS(CMyView)));
#endif

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

#ifdef _MDI
	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line. Since this is a read-only viewer,
	// don't allow FileNew
	if (cmdInfo.m_nShellCommand!=CCommandLineInfo::FileNew && 
		!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

#else // SDI app
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
#endif

	return TRUE;
}

void CApp::OnAppAbout()
{
	CDialog(IDD_ABOUTBOX, m_pMainWnd).DoModal();
}
